c     ******************************************************************
c
c     General utilities for Draw_PS  by Keith J. Halford    2/07/00
c
c     ******************************************************************
c
c ---------------------------------------------------------------------------------
c
      function irevdex(txt,ipos,char)
      character*1   char
      character*2048 txt
c
      i = ipos
      do while( i.gt.1 )
        i = i - 1
        if( txt(i:i) .eq. char) then
          irevdex = i
          i = 0
        endif
      enddo
c
      return
      end
c
c ---------------------------------------------------------------------------------
c
      integer function itxend( txt, n )
	character*2048 txt
	k = n
	do while( txt(k:k).eq.' ' .and. k.ge.1 )
	  k = k - 1
      enddo
      itxend = k
c
      return
      end
c
c ---------------------------------------------------------------------------------
c
      integer function ifrl( r )
	ip = abs(r) + 0.5
	if( r .lt. 0.000 )  ip = -ip
	ifrl = ip
      return
      end
c ---------------------------------------------------------------------------------
c
      subroutine TrimALL(sTxT)
      CHARACTER sTxT*(*)
C
      L = len(trim(sTxT))
      DO while (sTxT(1:1).eq.' ' .and. L.gt.0 ) 
        sTxT = sTxT(2:L)
      end do
      sTxT = trim(sTxT) 
c
      RETURN
      END
c
c___________________________________________________
c
c   NCREAD: reads lines of input and ignores lines that begin with a "#" sign.
c          All information after a ! is wiped from the input card. 
      subroutine ncread(io,txt,sNOL,sNOR,ierr)
      include 'T-COMP_Mini.inc'
      real rn(lrna)
      character*5   sNOR
      character*5   sNOL
      character*2048  afile
      character*2048  txt,tx2
      integer ki
	data ioflip,ioalt /69,69/
	maxalp = 2048
c
      ierr = 0
    5 read(io,'(a)',end=10)  txt
      call TrimALL(sNOL)
      ki = len(trim(sNOL))
      if( txt(1:ki) .eq. sNOL(1:ki) )  goto 5
      call tab2space(txt)     !!   Replace all tabs with spaces
c
      call TrimALL(sNOR)
      ki = len(trim(sNOR))
	ki = index(txt,sNOR(1:ki))
	if( ki.gt.0 ) then
	  txt(ki:maxalp) = '                                             '
	endif
c
      tx2 = txt
      call UPCASE(tx2)
c
c    Test for switching control to an auxilary input file
c
      ki = index(txt,':')
      if( index(tx2,'REDIRECT').gt.0 .and. ki.gt.0 ) then
	  afile = txt(ki+1:maxalp) 
	  ki = index(afile,'  ') - 1
        iohold = io
        io = ioflip
        ioflip = iohold 
        open(io,file=afile(1:ki),status='OLD',err=20)
c  Check for skipping lines   
        ki = index(tx2,'SKIPLINES=')
        if( ki.gt.0 )then
          ki = ki+len('SKIPLINES=')
          afile = txt(ki:maxalp) 
          call qread(rn,1,afile,ierrQ)
          ki = ifrl(rn(1))
          write(*,*)'  Skipping ',ki,' lines.'
          do i = 1,ki
            read(abs(io),'(a)',end=10) afile
          enddo
        endif
c  Check for parsing data         
c        if( index(tx2,'PARSEONE').gt.0 ) sNOR(10:10) = 'P'
        goto 5   
	endif
c
c    Test for returning io control from auxillary input to master input file
c
      if( index(tx2,'RETURN')  .gt.0 .and.
     +    index(tx2,'CONTROL') .gt.0      ) goto 10 
c
      ki = index(tx2,'<END>')
      if( ki .gt. 0 ) then
	  ierr = 1
	  txt(ki+5:maxalp) = '                                           '
	endif
c
      if( index(tx2,'<STOP>') .gt. 0 ) ierr = 2
      return
c
c    Report error in opening auxillary input file and stop MODOPTIM
c
   20 write(*,*)
      write(*,*) '  ERROR opening auxillary input file  '
      write(*,*)
      write(*,'(2x,10h The file:,2x,a40,16h does not exist.)')  afile
      write(*,*) 
      stop ' ' 
c
   10 txt(1:3) = 'EOF'
      sNOR(5:5) = ' '
      if( io .eq. ioalt ) then 
        close(io)
        iohold = io
        io = ioflip
        ioflip = iohold 
        goto 5   
	else
        ierr = -1
	endif
c
      return
      end
c
c___________________________________________________
c
      subroutine tab2space(txt)
      character*1   tab                                                      
      CHARACTER txt*(*)
      integer iMax
      tab = char(9)                         !!     sets  tab delimiter
c                                                                             
      iMax = LEN(txt)
      do i = 1, iMax
        if( txt(i:i).eq.tab ) txt(i:i) = ' '
      enddo
c                                                                             
      return                                                                  
      end                                                                     
c ---------------------------------------------------------------------------------
c
      subroutine replace(txt,cf,cr,n)
      character*1 qs,qd
      character*1 cf,cr
      character*2048  txt
c
      write(qs,100)
  100 format(1h')
      write(qd,'(1h")')
c
      iqs = 0
      iqd = 0
      do i = 1, n
        if( txt(i:i).eq.qs .and. mod(iqd,2).eq.0 ) iqs = iqs + 1
        if( txt(i:i).eq.qd .and. mod(iqs,2).eq.0 ) iqd = iqd + 1
        if( txt(i:i).eq.cf .and. mod(iqs,2).eq.0 .and. mod(iqd,2).eq.0 )
     +      txt(i:i) = cr
      enddo
c
      return
      end
c
c ---------------------------------------------------------------------------------
c
      subroutine stripquote(txt,n)
      character*1 qs,qd
      character*2048  txt
c
      write(qs,100)
  100 format(1h')
      write(qd,'(1h")')
c
      iqs = 0
      iqd = 0
      do i = 1, n
        if( txt(i:i).eq.qs .and. mod(iqd,2).eq.0 ) then
          iqs = iqs + 1
          txt(i:i) = ' '
        endif
        if( txt(i:i).eq.qd .and. mod(iqs,2).eq.0 ) then
          iqd = iqd + 1
          txt(i:i) = ' '
        endif
      enddo
c
      return
      end
c
c ---------------------------------------------------------------------------------
c
      integer function indexq(txt,n, tx2,ksf)
      character*1 qs,qd
      character*2048  txt, tx2
c
      write(qs,100)
  100 format(1h')
      write(qd,'(1h")')
c
      indexq = 0
      iqs = 0
      iqd = 0
	i = 0
      do while ( i.lt.n-ksf )
        i = i + 1
        ie = i + ksf-1
        if( txt(i:i).eq.qs .and. mod(iqd,2).eq.0 ) iqs = iqs + 1
        if( txt(i:i).eq.qd .and. mod(iqs,2).eq.0 ) iqd = iqd + 1
        if( txt(i:ie).eq.tx2(1:ksf) .and.
     +      mod(iqs,2).eq.0 .and. mod(iqd,2).eq.0 ) then
          indexq = i
          i = n
        endif
      enddo
c
      return
      end
c
c ---------------------------------------------------------------------------------
c
      subroutine shorten(txt,test,n,tx2)
      character*2048 txt,tx2,test
c
      tx2 = '???????'
      ki = index(txt,test(1:n))
      if(ki.gt.0) then
        tx2 = txt(ki:128)
        kc = index(tx2,':')+1
        tx2 = tx2(kc:128)
        kc = index(tx2,':')+1
        if( kc .gt. 1 ) tx2 = tx2(1:kc-1)
      endif
      return
      end
c
c ---------------------------------------------------------------------------------
c
      subroutine conden(txt,n)
      character*2048 txt
	mchr = 2048
c
      if(n.gt.mchr/2) n = mchr/2
      do  i = 1,mchr-n
        txt(n+i:n+i)=' '
      enddo
c
      l=0
      do k = 1, n*2
        l=l+1
        if(txt(l:l).eq.' ')then
          do m=l,n
            txt(m:m)=txt(m+1:m+1)
          enddo
          l = l-1
        endif
      enddo
      return
      end
c
c ---------------------------------------------------------------------------------
c
      subroutine noleadblank(txt,n)
      character*2048 txt
	mchr = 2048
c
	nm = n
      if(nm.gt.mchr) nm=mchr
c
	i = 0
      do while( txt(1:1).eq.' ' .and. i.lt.nm )
        txt = txt(2:mchr)
        i = i + 1
      enddo
c
      return
      end
c
c ---------------------------------------------------------------------------------
c
      subroutine reform(f,n)
      character*64 f
      if(n.gt.64) n=64
      write(*,*)'  N IN REFORM=',n
      f=','//f(2:n)
      do 10 i=1,n
         if(f(i:i).eq.'X' .or. f(i:i).eq.'x') then
         do l=1,5
         j=i-l
             if(f(j:j).eq.',') then
             jb=j+1
             je=j+l-1
             f= f(1:j)//'A'//f(jb:je)//f(i+1:n)
             goto 10
             endif
         enddo
         endif
   10 continue
      f='('//f(2:n)
      return
      end
c
c ---------------------------------------------------------------------------------
c
      subroutine bakped(n,io)
c
      do i=1,n
        backspace(io)
	enddo
c
      return
      end
c
c ---------------------------------------------------------------------------------
c
      subroutine qread(r,ni,ain,ierr)
      include 'T-COMP_Mini.inc'
      dimension r(lrna)
      character*1   tab
      character*16  form
      character*2048 aTEMP,ain
	tab = char(9)
	mchr = 2048
c
c   r(ni+1) records the number of non-numeric entries that were attempted to be read as a number
c   r(ni+2) records the last column that was read from the card
c
      r(ni+1) = -1.0000
      aTEMP = ain
      do i = 1, mchr
        if( aTEMP(i:i).eq.tab ) aTEMP(i:i) = ' '
        if( aTEMP(i:i).eq.',' ) aTEMP(i:i) = ' '
        if( aTEMP(i:i).eq.':' ) aTEMP(i:i) = ' '
        if( aTEMP(i:i).eq.'=' ) aTEMP(i:i) = ' '
      enddo
      n = 1
      i = 0
   11 r(ni+1) = r(ni+1) + 1
   10 i = i+1
      if( i.ge.mchr) goto 15
      if( aTEMP(i:i).eq.' ' ) then
        aTEMP(i:i) = '?'
        goto 10
      endif
c
      ki = index(aTEMP,' ')-1
      nd = ki - i + 1
      form ='(F??.0)              '
      write(form(3:4),'(i2.2)') nd
      READ (ATEMP(I:KI),FORM,ERR=13,IOSTAT=ISTAT) R(N)
   13 CONTINUE
      i = ki
      IF (ISTAT.GT.0) GOTO 11  ! PART OF BUG FIX -- ERB
      n = n+1
      if( n.le.ni .and. i.lt.mchr) goto 10
c
  15  n  = n-1
      ierr = ni - n
	r(ni+2) = i
      return
      end
c ---------------------------------------------------------------------------------
c   Find minimum distance between points in 2 arcs
c
	subroutine arcsmin(x1,y1, n1, x2,y2, n2, ip1, ip2 )
      include 'T-COMP_Mini.inc'
      dimension x1(ln1), y1(ln1), x2(ln1), y2(ln1)
c
	dlmin = 1e30
c
	do j = 1, n2
        do i = 1, n1
          dl = seglen(x1(i),y1(i),x2(j),y2(j))
          if( dl.lt.dlmin ) then
            dlmin = dl
            ip1 = i
            ip2 = j
          endif
        enddo
	enddo
c
      return
	end
c ---------------------------------------------------------------------------------
c
c   Point reduction for disconnected points in pageunits.
c                              (Assume X & Y scales are equivalent)
c
	subroutine pointless(dlmin, x,y,npt )
      include 'T-COMP_Mini.inc'
      dimension x(ln1), y(ln1)
	cut = -1e8
c
	do j = 1, npt-1
        do i = j+1, npt
          if( x(j).gt.cut .and. x(i).gt.cut ) then
            dl = seglen(x(i),y(i),x(j),y(j))
            if( dl.lt.dlmin )  x(j) = cut*10
          endif
        enddo
	enddo
c
      return
	end
c
c ---------------------------------------------------------------------------------
c
	function seglen(x1,y1,x2,y2)
c
c   Compute Segment length
      dx = x2 - x1
      dy = y2 - y1
      seglen = (dx**2 + dy**2)**0.5
c
      return
	end
c
c ---------------------------------------------------------------------------------
c
	subroutine abline(x1,y1,x2,y2, a,b)
	zero = 1.e-30
c
      dx = x2 - x1
      dy = y2 - y1
c   Compute slope of line
	if( abs(dx) .lt. zero) then
	  a = dy / zero
	  b = x2
      else
	  a = dy / dx
c   Compute y-intercept of line
        b = y1 - a*x1
      endif
c
      return
	end
c
c ---------------------------------------------------------------------------------
c
	function flat(x1,y1,x2,y2, x,y )
	zero = 1.e-30
c
      dx = x2 - x1
      dy = y2 - y1
c
c   Compute perpendicular distance from the line defined by a,b to <x,y>
c
	if( abs(dx) .lt. zero) then
        xp = x1
        yp = y
	elseif( abs(dy) .lt. zero) then
        xp = x
        yp = y1
	else
        call abline(x1,y1,x2,y2, a,b)
        a2 = -1. / a
        b2 = y - a2*x
        da = a - a2
        db = b - b2
        if( abs(da) .lt. zero) then
	    xp = -db / zero
        else
          xp = -db / da
        endif
        yp = a*xp + b
	endif
c
	flat = seglen(x,y,xp,yp)
c
      return
	end
c
c ---------------------------------------------------------------------------------
c
      function devang(x,y,n)
      include 'T-COMP_Mini.inc'
      dimension x(ln1),y(ln1)
	zero = 1.e-30
      pi   = 3.14159265
c
      devang = 0.00000
      if( n.lt.2 ) return
c
c compute dx, dy components of segment and vector to estimation point
c
      dxb = x(n-1) - x(n)
      dyb = y(n-1) - y(n)
      dlb = dxb**2 + dyb**2
      dxf = x(n+1) - x(n)
      dyf = y(n+1) - y(n)
      dlf = dxf**2 + dyf**2
c
      if( dlb.gt.zero .and. dlf.gt.zero ) then
c  compute angle between vectors
        rad = v2rad(dxb,dyb,dxf,dyf)
	  devang = pi - rad
	endif
c
      return
      end
c
c ---------------------------------------------------------------------------------
c
	function v2rad(dx1,dy1,dx2,dy2)
      zero=1.e-8
      pi=3.14159265
c
c  Report all angles as swung through a counterclockwise arc from vector 1 to 2
c
	ang1 = fang(dx1,dy1)
	ang2 = fang(dx2,dy2)
	if( ang2 .lt. ang1 ) ang2 = ang2 + 2*pi
	v2rad = ang2 - ang1
c
      return
      end
c
c ---------------------------------------------------------------------------------
c
      function fang(dx,dy)
      zero=1.e-8
      pi=3.14159265
      if(abs(dx) .gt. zero) then
        rat=dy/dx
        fang=atan(rat)
      else
        fang=pi/2
        if(dy.lt.0.0) fang=-fang
      endif
      if( dx .lt.-zero) fang = fang - pi
	if( fang .lt. -zero)  fang = fang + 2*pi
      return
      end
c
c ---------------------------------------------------------------------------------
c
      real function polyarea(x,y,n)
      include 'T-COMP_Mini.inc'
      dimension x(ln1),y(ln1)
c
c    Area of polygon by SUM  x2*y1 - y2*x1
c    + areas denote a Clockwise curve
c    - areas denote a Counterclockwise curve
c
      polyarea = x(1)*y(n) - x(n)*y(1)
c
      do i = 2, n
        add=x(i)*y(i-1) - x(i-1)*y(i)
        polyarea = polyarea + add
      enddo
      polyarea = polyarea / 2
c
      return
      end
c
c ---------------------------------------------------------------------------------
c
      subroutine rotate(x1,y1,x2,y2,ang,scale,xr1,yr1,xr2,yr2)
c
      dx = x1-xr1
      dy = y1-yr1
      th1 = fang( dx, dy)
      radius = ( dx**2 + dy**2 )**0.5
      th2 = th1 + ang
      x2 = xr2 + radius*cos(th2) * scale
      y2 = yr2 + radius*sin(th2) * scale
c      
      return
      end
c
