c
      subroutine LocalINFO(io,iout,sNOL,sNOR,sVAR, nLITH,sLITH,
     +         rLITHprop,nWells,sWelNAME,rWelX,rWelY, nWelINT,rWelINT,
     +                   rDDthresh, rRADmin, rRADmax, 
     +                   rDEFsy,rDEFss,rDEFrHV,sSubMini,
     +                   rQfrac, rLAYfrac)
      include 'T-COMP_Mini.inc'
      character*5   sNOR
      character*5   sNOL
      character*5   sVAR
      CHARACTER*64 sSubMini
      CHARACTER*64 sWelNAME(nMAXwell)
      CHARACTER*64  sLITH(nMAXlith)
      CHARACTER*2048 sTxT
      real rDDthresh
      real rRADmin 
      real rRADmax, rQfrac
      real rLAYfrac
      real rDEFsy 
      real rDEFss 
      real rDEFrHV
      real rEasting 
      real rNorthing 
      real rRotateRADIAN
      real rLITHprop(nMAXlith,4)
      real rn(lrna)
      real rWelX(nMAXwell)
      real rWelY(nMAXwell)
      real rWelINT(nMAXint)
      INTEGER nWelINT(nMAXwell)
      INTEGER nWells
      INTEGER ierr
      INTEGER io
      INTEGER i
      INTEGER nLITH
      INTEGER ki
c      
      call sGET(io,sNOL,sNOR,ierr, 'Subdirectory:',sSubMini) 
      write(IOUT,'(A28,a32)')'  Minimodel subdirectory is:', sSubMini
      write(IOUT,*) 
c      
      rLAYfrac  = rGET(io, sNOL, sNOR, ierr)                         
      if( rLAYfrac.gt.1.0 ) rLAYfrac = 1.00
      rQfrac  = rGET(io, sNOL, sNOR, ierr)                               !! Fraction of Maximum Horizontal Flow  = 0.5 ft
      if( rQfrac.gt.1.0 ) rQfrac = 1.00
      if( rQfrac.lt.0.1 ) rQfrac = 0.1
      rDDthresh = rGET(io, sNOL, sNOR, ierr)                             !! Threshold Drawdown = 0.5  ft
      rRADmin = rGET(io, sNOL, sNOR, ierr)                               !! Maximum radius for integrating Transmissivity
      rRADmax = rGET(io, sNOL, sNOR, ierr)                               !! Maximum radius for integrating Transmissivity
      write(IOUT,*) ' Intersect full layer thickness if fraction '//
     +  'intersected exceeds =', rLAYfrac
      write(IOUT,*) ' Fraction of Maximum Horizontal Flow =', rQfrac
      write(IOUT,*) ' Threshold Drawdown = ', rDDthresh  
      write(IOUT,*) ' Minimum radius for integrating T = ', rRADmin
      write(IOUT,*) ' Maximum radius for integrating T = ', rRADmax
      write(IOUT,*) 
      rDEFsy = rGET(io, sNOL, sNOR, ierr)                
      rDEFss = rGET(io, sNOL, sNOR, ierr)                
      rDEFrHV = rGET(io, sNOL, sNOR, ierr)               
      write(IOUT,*) ' Default specific yield = ', rDEFsy  
      write(IOUT,*) ' Default specific storage = ', rDEFss
      write(IOUT,*) ' Default horiz-to-vert. anisotropy  = ', rDEFrHV
      write(IOUT,*) 
c
c   Easting,    Northing       Rotation in degrees   of Regional Model --- 
c   Reference is to Upper, Left corner of model prior to rotation.  
      rEasting = rGET(io, sNOL, sNOR, ierr) 
      rNorthing = rGET(io, sNOL, sNOR, ierr) 
      rRotateRADIAN = rGET(io, sNOL, sNOR, ierr) 
      write(IOUT,*) ' Easting, Northing of upper, left corner ', 
     +     rEasting, rNorthing 
      write(IOUT,*)'Rotation of model, degrees, + is counterclockwise',
     +               rRotateRADIAN
      write(IOUT,*) 
      rRotateRADIAN = rRotateRADIAN * 3.14159 / 180.0
c
c  read  lith table 
c    Lithology        K, ft/d   Specific Yield,   Specific storage, 1/ft,   Vertical-to-Horizontal anisotropy
      i = 0
      do while(i .lt. nMAXlith )
        call ncread(io,sTxT,sNOL,sNOR,ierr)
        if( ierr.lt.1 ) then
          i = i + 1 
          call TrimALL(sTxT)
          call UPCASE(sTxT)
          ki = index(sTxT,' ')
          sLITH(i) = sTxT(1:ki)//'                            '
          ierr = len(sTxT)
          sTxT = sTxT(ki:ierr)
          call qread(rn,4,sTxT,ierr)
          rLITHprop(i,1) = rn(1) 
          rLITHprop(i,2) = rn(2)
          rLITHprop(i,3) = rn(3)
          rLITHprop(i,4) = rn(4)
        else
          nLITH = i
          i = nMAXlith
        endif
      end do !  end of lith table loop 
C
c   Echo lith table 
      write(IOUT,'(A132)') ' Lithology,         K,  Specific Yield, '//
     +         'Specific storage,  Vertical-to-Horizontal anisotropy'
      do i = 1, nLITH
        write(IOUT,'(2x,A32,4G15.7)') sLITH(i),(rLITHprop(i,j),j=1,4) 
      enddo         
      write(IOUT,*) 
c
c  Define Wells  location & construction  ___________________________________
      call WellDEFINE(io,sNOL,sNOR, nWells,sWelNAME,rWelX,rWelY, 
     +                nWelINT,rWelINT )
c  Translate to model XY  ___________________________________
      call WellSPIN(nWells,rWelX,rWelY,rEasting,rNorthing,rRotateRADIAN)
c
c   Pass REF coordinates by sticking in XY arrays at nWells+1
      rWelX(nWells+1) = rEasting 
      rWelY(nWells+1) = rNorthing
c
c   Echo Well construction  
      write(IOUT,'(A132)')' Well name,     Easting (X),  Northing (Y),'
     +   // '  Top of Screen,   Bottom of Screen'
      do i = 1, nWells
        n = nWelINT(i)
        write(IOUT,'(2x,A32,4G15.7)') sWelNAME(i),rWelX(i),rWelY(i), 
     +        (rWelINT(j),j=n+1,n+2)
        if( nWelINT(i+1) .gt. n+2 ) then
          write(IOUT,'(64x,2G15.7)') (rWelINT(j),j=n+3,nWelINT(i+1))
        endif  
      enddo         
      write(IOUT,*) 
c  
      return
      end
c ---------------------------------------------------------------------------------
      subroutine WellDEFINE(io, sNOL, sNOR,nWells,sWelNAME,
     +                      rWelX, rWelY, nWelINT, rWelINT)
      include 'T-COMP_Mini.inc'
      character*5   sNOR
      character*5   sNOL
      CHARACTER*64 sWelNAME(nMAXwell)
      CHARACTER*2048 sTxT
      CHARACTER*2048 sTx2
      real rn(lrna)
      real rWelX(nMAXwell)
      real rWelY(nMAXwell)
      real rWelINT(nMAXint)
      INTEGER nWelINT(nMAXwell)
      INTEGER nWells
      INTEGER ierr
      INTEGER io
      INTEGER i
      INTEGER j
      INTEGER n
      INTEGER ki
      integer iMAXtb
c
      iMAXtb = 20
      i = 0
      n = 0
      do while(i .lt. nMAXwell )
        call ncread(io,sTxT,sNOL,sNOR,ierr)
        if( ierr.lt.1 ) then
          call TrimALL(sTxT)
          sTx2 = sTxT 
          call UPCASE(sTx2)
          ki = index(sTx2,'WELL:')
          if( ki.gt.0 ) then                                               !!        TEST on WELL: key
            sTxT = sTxT(ki+5:len(sTxT))
            i = i + 1 
            ki = index(sTxT,' ')
            sWelNAME(i) = sTxT(1:ki)//'                            '
            sTxT = sTxT(ki:len(sTxT))
            call qread(rn,2,sTxT,ierr)
            rWelX(i) = rn(1) 
            rWelY(i) = rn(2)
            sTxT = sTxT(int(rn(4))+1:len(sTxT))
            nWelINT(i) = n
          endif 
          call qread(rn,iMAXtb,sTxT,ierr)
          ki = iMAXtb-ierr
          do j = 1, ki
            rWelINT(n + j) = rn(j)
          end do  
          n = n + ki
        else
          nWells = i
          i = nMAXwell
          nWelINT(nWells+1) = n
        endif
      end do !  end of lith table loop 
c
      return
      end  
c ---------------------------------------------------------------------------------
      subroutine WellSPIN(nWells, rWelX, rWelY, 
     +                    rEasting, rNorthing, rRotateRADIAN)
      include 'T-COMP_Mini.inc'
      real rWelX(nMAXwell)
      real rWelY(nMAXwell)
      INTEGER nWells
      INTEGER i
c
      do i = 1, nWells
        call rotate(rWelX(i),rWelY(i),rWelX(i),rWelY(i),
     +         -1.*rRotateRADIAN,1.0,rEasting, rNorthing,0.,0.)
      end do !  end of well spinning 
c
      return
      end  
c ---------------------------------------------------------------------------------
