      MODULE TcompReduceMODULE
c       INTEGER, SAVE, POINTER ::IBCFCB,IWDFLG,IWETIT,IHDWET
c       REAL, SAVE, POINTER    ::WETFCT
       REAL, SAVE,     POINTER,   DIMENSION(:,:,:) ::rSbar
       REAL, SAVE,     POINTER,   DIMENSION(:,:,:) ::rTbar
       REAL, SAVE,     POINTER,   DIMENSION(:,:,:) ::rKvBar
       REAL, SAVE,     POINTER,   DIMENSION(:,:,:) ::rKvKh
       REAL, SAVE,     POINTER,   DIMENSION(:,:,:) ::rThk
       REAL, SAVE,     POINTER,   DIMENSION(:)     ::rXE
       REAL, SAVE,     POINTER,   DIMENSION(:)     ::rYE
c       REAL, SAVE,     POINTER,   DIMENSION(:)     ::TRPY
      TYPE TcompReduceTYPE
c       INTEGER, POINTER  ::IBCFCB,IWDFLG,IWETIT,IHDWET
c       REAL, POINTER     ::WETFCT
       REAL,     POINTER,   DIMENSION(:,:,:) ::rSbar
       REAL,     POINTER,   DIMENSION(:,:,:) ::rTbar
       REAL,     POINTER,   DIMENSION(:,:,:) ::rKvBar
       REAL,     POINTER,   DIMENSION(:,:,:) ::rKvKh
       REAL,     POINTER,   DIMENSION(:,:,:) ::rThk
       REAL,     POINTER,   DIMENSION(:) ::rXE
       REAL,     POINTER,   DIMENSION(:) ::rYE
c       REAL,     POINTER,   DIMENSION(:)     ::TRPY
      END TYPE
      TYPE(TcompReduceTYPE), SAVE  ::TcompReduceDAT(10)
      END MODULE TcompReduceMODULE
c____________________________________________________________
c____________________________________________________________
c
      SUBROUTINE Cond2Tran(IGRID)
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      USE GLOBAL
      USE TcompReduceMODULE
      integer iLNK
      real dMULT
      real dTRAN
      real rKtemp
C
C     ------------------------------------------------------------------
C1------ALLOCATE SCALAR VARIABLES IN FORTRAN MODULE.
c      ALLOCATE(IBCFCB,IWDFLG,IWETIT,IHDWET)
c      ALLOCATE(WETFCT)
c      ALLOCATE(LAYCON(NLAY),LAYAVG(NLAY))
C6------ALLOCATE SPACE FOR ARRAYS.
      ALLOCATE(rSbar(NCOL,NROW,NLAY))
      ALLOCATE(rTbar(NCOL,NROW,NLAY))
      ALLOCATE(rKvBar(NCOL,NROW,NLAY))
      ALLOCATE(rKvKh(NCOL,NROW,NLAY))
      ALLOCATE(rThk(NCOL,NROW,NLAY))
      ALLOCATE(rXE(NCOL+1))
      ALLOCATE(rYE(NROW+1))
      dZero = 1.0E-10
c      CALL TcompReducePNT(IGRID)
      rXE(1) = 0.00000000000
      DO I=1,NCOL
        rXE(i+1) = rXE(i) + delr(i)
      end do
      rYE(1) = 0.00000000000
      DO J=1,NROW
        rYE(j+1) = rYE(j) - delc(j)
      end do
c
c   Create XE & YE arrays
C
c     Use geometric means to collapse T to node-centered properties............... 
      DO K=1,NLAY
        DO I=1,NROW
          DO J=1,NCOL
            if( Ibound(j,i,k).ne.0 ) then
              dMULT = 0.
              iLNK = 0
c        --------------------------Left/Right-----------             
              if( j.gt.1 ) then
                if(Ibound(j-1,i,k).ne.0 .and. cr(j-1,i,k).gt.dZero) then
                  dTRAN = cr(j-1,i,k)*(delr(j-1)+delr(j))/delc(i)/2.
                  dMULT = dMULT + log10(dTRAN)
                  iLNK = iLNK + 1
                endif
              endif
c        --------------------------RIGHT-----------             
              if( j.lt.ncol ) then
                if( Ibound(j+1,i,k).ne.0 .and. cr(j,i,k).gt.dZero) then
                  dTRAN = cr(j,i,k)*(delr(j+1)+delr(j))/delc(i)/2.
                  dMULT = dMULT + log10(dTRAN)
                  iLNK = iLNK + 1
                endif
              endif
c        -------------------------- BACK -----------             
              if( i.gt.1 ) then
                if(Ibound(j,i-1,k).ne.0 .and. cc(j,i-1,k).gt.dZero) then
                  dTRAN = cc(j,i-1,k)*(delc(i-1)+delc(i))/delr(j)/2.
                  dMULT = dMULT + log10(dTRAN)
                  iLNK = iLNK + 1
                endif
              endif
c        -------------------------- FRONT -----------             
              if( i.lt.nrow ) then
                if(Ibound(j,i+1,k).ne.0 .and. cc(j,i,k).gt.dZero) then
                  dTRAN = cc(j,i,k)*(delc(i+1)+delc(i))/delr(j)/2.
                  dMULT = dMULT + log10(dTRAN)
                  iLNK = iLNK + 1
                endif
              endif
c              
              rTbar(j,i,k) = 10.**(dMULT/iLNK)
              if( botm(j,i,k-1) .gt. botm(j,i,k)+dZero ) then
                rThk(j,i,k) = botm(j,i,k-1) - botm(j,i,k)
              else
                rThk(j,i,k) = 1.0
              endif  
            else
              rTbar(j,i,k) = 0.
              rThk(j,i,k) = 1.0
            endif
          enddo
        enddo
      enddo
C
c     Use geometric means to collapse T to node-centered properties............... 
      DO K=1,NLAY
        DO I=1,NROW
          DO J=1,NCOL
            if( Ibound(j,i,k).ne.0 ) then
              dMULT = 0.
              iLNK = 0
c        -------------------------- TOP -----------             
              if( k.gt.1 ) then
                if(Ibound(j,i,k-1).ne.0 .and. cv(j,i,k-1).gt.dZero) then
                  rKtemp = cv(j,i,k-1) * (rThk(j,i,k-1)+rThk(j,i,k))/2.
                  rKtemp = rKtemp / delc(i)/delr(j)
                  dMULT = dMULT + log10(rKtemp)
                  iLNK = iLNK + 1
                endif
              endif
c        -------------------------- bottom -----------             
              if( k.lt.nlay ) then
                if(Ibound(j,i,k+1).ne.0 .and. cv(j,i,k+1).gt.dZero) then
                  rKtemp = cv(j,i,k+1) * (rThk(j,i,k+1)+rThk(j,i,k))/2.
                  rKtemp = rKtemp / delc(i)/delr(j)
                  dMULT = dMULT + log10(rKtemp)
                  iLNK = iLNK + 1
                endif
              endif
c              
              rKtemp = 10.**(dMULT/iLNK)
              rKvBar(j,i,k) = rKtemp
              rKtemp = rTbar(j,i,k) / rThk(j,i,k)
              rKvKh(j,i,k) = rKvBar(j,i,k) / rKtemp
              rSbar(j,i,k) = rhs(j,i,k) / delc(i)/delr(j)
            else
              rSbar(j,i,k) = 0.
              rKvBar(j,i,k) = 0.
              rKvKh(j,i,k) = 1.0
            endif
          enddo
        enddo
      enddo
C
C10-----SAVE POINTERS FOR TcompReduce AND RETURN.
      CALL TcompReducePSV(IGRID)
      RETURN
      END
c_________________________ MECHANICAL CRAP _______________________________      
c
      SUBROUTINE TcompReduceDA(IGRID)
      USE TcompReduceMODULE
C
      DEALLOCATE(TcompReduceDAT(IGRID)%rSbar)
      DEALLOCATE(TcompReduceDAT(IGRID)%rTbar)
      DEALLOCATE(TcompReduceDAT(IGRID)%rKvBar)
      DEALLOCATE(TcompReduceDAT(IGRID)%rKvKh)
      DEALLOCATE(TcompReduceDAT(IGRID)%rThk)
      DEALLOCATE(TcompReduceDAT(IGRID)%rXE)
      DEALLOCATE(TcompReduceDAT(IGRID)%rYE)
C
      RETURN
      END
c______________________________________________________      
      SUBROUTINE TcompReducePNT(IGRID)
      USE TcompReduceMODULE
C
      rSbar=>TcompReduceDAT(IGRID)%rSbar
      rTbar=>TcompReduceDAT(IGRID)%rTbar
      rKvBar=>TcompReduceDAT(IGRID)%rKvBar
      rKvKh=>TcompReduceDAT(IGRID)%rKvKh
      rThk=>TcompReduceDAT(IGRID)%rThk
      rXE=>TcompReduceDAT(IGRID)%rXE
      rYE=>TcompReduceDAT(IGRID)%rYE
C
      RETURN
      END
c______________________________________________________      
      SUBROUTINE TcompReducePSV(IGRID)
      USE TcompReduceMODULE
C
      TcompReduceDAT(IGRID)%rSbar=>rSbar
      TcompReduceDAT(IGRID)%rTbar=>rTbar
      TcompReduceDAT(IGRID)%rKvBar=>rKvBar
      TcompReduceDAT(IGRID)%rKvKh=>rKvKh
      TcompReduceDAT(IGRID)%rThk=>rThk
      TcompReduceDAT(IGRID)%rXE=>rXE
      TcompReduceDAT(IGRID)%rYE=>rYE
C
      RETURN
      END
c
